var starturl = "https://northtorontoauction.com/?app=true&amp;version=2";
var pdomain = 'northtorontoauction.com';
var protocol = 'https://';
var camera_retries = 0;
var imagetag = '';
var apptitle = 'NTA Mobile';

var iOS = ( navigator.userAgent.match(/(iPad|iPhone|iPod)/g) ? true : false );

mainframe = {};
mainframediv = document.getElementById('main');
welcomediv = document.getElementById('welcome');

function sendMessage(object)
{
	mainframe.contentWindow.postMessage(object, protocol + pdomain);
}

function hideMainframe()
{
	if(mainframediv.className == 'visible')
		mainframediv.className = 'hidden';
	if(welcomediv.className == 'hidden')
		welcomediv.className = 'visible';
}

function showMainframe()
{
	if(navigator.network.connection.type == Connection.NONE)
	{
		navigator.notification.alert(apptitle + ' requires an active Internet connection.', function(){return true}, 'Disconnected', 'OK');
	}
	else
	{
		if(mainframediv.className == 'hidden')
			mainframediv.className = 'visible';
		if(welcomediv.className == 'visible')
			welcomediv.className = 'hidden';
	}
}

function scanMulti()
{
	hideMainframe();
	cordova.plugins.barcodeScanner.scan
	(
		function(result)
		{
			if(result.cancelled == true)
			{
				navigator.notification.confirm(
					'Low-res cameras may have trouble scanning VIN plates.'
					, function(button) {
						if (button == 1) {
							mainframe.contentWindow.location.href = protocol + pdomain + '/search.php?type=vin';
							showMainframe();
						}
						if (button == 2) {
							showMainframe();
						}
					}
					, 'Options'
					, ["Type It", "Cancel"]
				);
			}
			else
			{
				if(result.text.indexOf('http') === 0)
				{
					if(result.text.indexOf(pdomain) > -1)
					{
						showMainframe();
						mainframe.src = result.text;
					}
					else
					{
						if(confirm('Would you like to open this link in your browser?'))
						{
							showMainframe();
							navigator.app.loadUrl(result.text, { openExternal:true } );
						}
					}
				}
				else if(result.text.length == 17)
				{
					mainframe.src = protocol + pdomain + '/search.php?vin=' + result.text;
					showMainframe();
				}
				else if(result.text.length == 18)
				{
					mainframe.src = protocol + pdomain + '/search.php?vin=' + result.text.substring(1);
					showMainframe();
				}
				else
				{
					if(result.text.length > 0)
					{
						navigator.notification.alert("Unknown Code Type", function(){return true;}, apptitle);
					}
					showMainframe();
				}
			}
		},
  
		function(error)
		{
			navigator.notification.alert("Scanning failed: " + error, function(){return true;}, apptitle);
		}
	);
}

function startScan(purpose) {
	cordova.plugins.barcodeScanner.scan
	(
		function(result)
		{
			sendMessage({type: 'result', module: 'scanner', purpose: purpose, result: result});
		},

		function(error)
		{
			alert("Scanning failed: " + error);
		}
	);
}

function messageProcessor(event)
{
	if(event.origin !== protocol + pdomain)
	{
		console.log('Access violation from ' + event.origin);
		return false;
	}

	if(event.data.type == 'request')
	{
		if(event.data.module == 'scanner')
		{
			if(event.data.purpose == 'multi')
			{
				scanMulti();
			}
			else
			{
				startScan(event.data.purpose);
			}
		}
		else if(event.data.module == 'ui')
		{
			if(event.data.purpose == 'menuButtonHandle')
			{
				menuButtonHandle();
			}
		}
		else if(event.data.module == 'camera')
		{
			camera_retries = 0;
			imagetag = event.data.imagetag;
			if(event.data.purpose == 'camera')
			{
				navigator.camera.getPicture(cameraSuccess, cameraFail,
				{
					quality: 100,
					destinationType: Camera.DestinationType.FILE_URI,
					sourceType: Camera.PictureSourceType.CAMERA
				});
			}
			else if(event.data.purpose == 'file')
			{
				navigator.camera.getPicture(cameraSuccess, cameraFail,
				{
					quality: 100,
					destinationType: Camera.DestinationType.FILE_URI,
					sourceType: Camera.PictureSourceType.SAVEDPHOTOALBUM
				});
			}
		}
		else if(event.data.module == 'share')
		{
			if(event.data.purpose == 'mainframe')
			{
				var share_string = mainframe.src;
				var share_clipped = share_string.replace('?app=true', '?');
				var share_double = share_clipped.replace('mobile=true', '');
				window.plugins.socialsharing.share(share_double, null, null, share_double);
			}
		}
		else if(event.data.module == 'notification')
		{
			if(event.data.purpose == 'alert')
			{
				navigator.notification.alert(event.data.message, function(){sendMessage({type: 'result', module: 'notification', purpose: event.data.purpose, result: true});}, apptitle);
			}
			else if(event.data.purpose == 'confirm')
			{
				navigator.notification.confirm(event.data.message, function(result){sendMessage({type: 'result', module: 'notification', purpose: event.data.purpose, result: result});});
			}
			else if(event.data.purpose == 'prompt')
			{
				navigator.notification.prompt(event.data.message, function(result){sendMessage({type: 'result', module: 'notification', purpose: event.data.purpose, result: result.input1});});
			}
			else if(event.data.purpose == 'beep')
			{
				if(typeof event.data.message !== "undefined")
				{
					var times = parseInt(event.data.message);
				}
				else
				{
					var times = 1;
				}
				navigator.notification.beep(times);
				sendMessage({type: 'result', module: 'notification', purpose: event.data.purpose, result: true});
			}
			else if(event.data.purpose == 'vibrate')
			{
				if(typeof event.data.message !== "undefined")
				{
					var ms = parseInt(event.data.message);
				}
				else
				{
					var ms = 300;
				}
				navigator.notification.vibrate(ms);
				sendMessage({type: 'result', module: 'notification', purpose: event.data.purpose, result: true});
			}
		}
		else if(event.data.module == 'navigation')
		{
			if(event.data.purpose == 'back')
			{
				history.go(-1);
				navigator.app.backHistory();
			}
			else if(event.data.purpose == 'menu')
			{
				hideMainframe();
			}
			else if(event.data.purpose == 'menubutton')
			{
				menuButtonHandle();
			}
			else if(event.data.purpose == 'browser')
			{
				window.open(event.data.message, '_system');
			}
		}
	}
}

function menuButtonHandle() {
	if(iOS)
	{
		navigator.notification.confirm(
			'What would you like to do?'
			, function(button) {
				if (button == 2) {
					return false;
				}
				if (button == 1) {
					mainframe.contentWindow.location.reload();
				}
			}
			, 'Options'
			, ["Refresh", "Cancel"]
		);
	}
	else
	{
		navigator.notification.confirm(
			'What would you like to do?'
			, function(button) {
				if (button == 2) {
					navigator.app.exitApp();
				}
				if (button == 1) {
					mainframe.contentWindow.location.reload();
				}
			}
			, 'Options'
			, ["Refresh", "Exit"]
		);
	}
}

function cameraSuccess(fileURI)
{
	var win = function (r) {
//		cameraClearCache();
		camera_retries = 0;
		if(r.response == 'error')
		{
			alert("There was a problem processing the file on the server. Please try again.");
		}
		else
		{
			sendMessage({type: 'result', module: 'camera', purpose: 'camera', result: r.response});
		}
	}

	var fail = function (error) {
		if (camera_retries == 0) {
			camera_retries ++;
			setTimeout(function() {
				cameraSuccess(fileURI)
			}, 60000)
		} else {
			camera_retries = 0;
//			cameraClearCache();
			alert('There was a problem uploading this image to the server. Code ' + error.code + ' HTTP ' + error.http_status);
		}
	}

	var options = new FileUploadOptions();
	options.fileKey = "file";
	options.fileName = fileURI.substr(fileURI.lastIndexOf('/') + 1);
	options.mimeType = "image/jpeg";
	options.params = {imagetag: imagetag};
	options.chunkedMode = false;
	var ft = new FileTransfer();
	ft.upload(fileURI, protocol + pdomain + '/api/mobile/camera', win, fail, options, true);
}

function cameraFail(message)
{
	sendMessage({type: 'result', module: 'camera', purpose: 'camera', result: 'cancelled'});
	if(message != 'Camera cancelled.' && message != 'no image selected')
		alert('Failed because: ' + message);

}

function cameraClearCache()
{
	navigator.camera.cleanup();
}

function cordovaResume()
{
	hideMainframe();
}

document.addEventListener("deviceready", cordovaInit, false);

function mainframeInit()
{
	mainframediv.innerHTML = '<iframe src="' + starturl + '" width="100%" height="100%" id="mainframe"></iframe>';
	mainframe = document.getElementById('mainframe');
}

function cordovaOnline(event)
{
	return true;
	navigator.notification.alert('Connection restored!');
}

function cordovaOffline(event)
{
	hideMainframe();
	navigator.notification.alert('Internet connection has been lost.', function(){return true}, 'Disconnected', 'OK');
}

function connectionCheck()
{
	if(navigator.network.connection.type == Connection.NONE)
	{
		navigator.notification.alert(apptitle + ' requires an active Internet connection.', function(){return true}, 'Disconnected', 'OK');
	}
}

function cordovaInit()
{
	if(iOS)
	{
		document.addEventListener("resume", cordovaResume);
	}
	else
	{
		document.getElementById('wbuttons').innerHTML = document.getElementById('wbuttons').innerHTML + '<div class="button" onclick="navigator.app.exitApp();"><img src="img/icons/exit.png" alt="[E]">Exit</div>';
		document.addEventListener("menubutton", menuButtonHandle);
	}
	
	window.addEventListener('online', cordovaOnline, false);
	window.addEventListener('offline', cordovaOffline, false);

	connectionCheck();

	mainframeInit();
}

window.addEventListener("message", messageProcessor);